<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <template>
                <div v-if="Projects.length === 0"
                     class="column items-center justify-center q-py-lg q-gutter-y-xl full-width text-center">
                    <div class="text-h4 text-weight-light">
                        Looks like you are not in any project!
                    </div>
                    <div class="text-body1  q-gutter-y-sm">
                        <div>
                            Ask your colleagues to add you to the project
                        </div>
                        <div>
                            Your username is
                            <span class="text-primary text-italic">{{ NameStart }}</span>
                            <span class="text-grey-6 text-italic">#{{ NameEnd }}</span>
                        </div>
                    </div>
                    <div class="text-body1">
                        or
                    </div>
                    <div>
                        Create a project yourself by click on button on the bottom right
                    </div>
                </div>
                <div v-else>
                    <h5 class="text-weight-light text-center">Choose a project to get started on</h5>
                    <div class="fit row wrap justify-center items-start content-start q-pa-md q-gutter-md">
                        <ProjectCard v-for="i in projects" :key="i.id" :project="i" @select="Select" @edit="Edit"

                                     @delete="Delete"/>
                    </div>
                </div>
                <q-btn fab color="accent" icon="add" class="fixed-bottom-right q-ma-lg" to="/project/create">
                    <q-tooltip anchor="center left" self="center right">
                        Create a new project
                    </q-tooltip>
                </q-btn>
            </template>

            <template #end>
                <q-dialog v-model="deleteDialog">
                    <DeleteProjectDialog :project='deleteTarget' class="bg-base" @deleted="Deleted"
                                         @back="deleteDialog = false"/>
                </q-dialog>
            </template>
        </DocumentWrapper>

    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import {ProjectPrincipalResponse} from "src/classLibrary/APIModels/core/projectPrincipalResponse";
import Container from "components/Core/Container.vue";
import ErrorComponent from "components/Core/ErrorComponent.vue";
import ProjectCard from "components/Entities/Card/ProjectCard.vue";
import DeleteProjectDialog from "components/Dialog/DeleteProjectDialog.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";

@Component({
    components: {DocumentWrapper, DeleteProjectDialog, ProjectCard, ErrorComponent, Container}
})
export default class Projects extends Vue {

    layoutTabs = [];
    projects: ProjectPrincipalResponse[] = [];

    errors: string[] = [];


    unknownError: any = "";

    deleteDialog = false;
    deleteTarget?: ProjectPrincipalResponse | null = null;

    async Deleted(p: ProjectPrincipalResponse) {
        this.deleteDialog = false
        await this.loadProjects();
        if (this.PersistentStore.StoreValue.project == p.id) {
            this.PersistentStore.StoreValue.project = '';
            this.PersistentStore.StoreValue.projectName = '';
        }
    }

    Edit(p: ProjectPrincipalResponse) {
        console.info(p);
    }

    Delete(p: ProjectPrincipalResponse) {
        this.deleteTarget = p;
        this.deleteDialog = true;
    }

    Select(p: ProjectPrincipalResponse) {
        this.PersistentStore.StoreValue.project = p.id;
        this.PersistentStore.StoreValue.projectName = p.name;
        this.$router.push("/")
    }

    get Projects(): ProjectPrincipalResponse[] {
        return this.projects;
    }

    get Name() {
        return this.$coreAuth.user?.principal.username.split("#") ?? ["", "0000"];
    }

    get NameEnd() {
        return this.Name[1];

    }

    get NameStart() {
        return this.Name[0];
    }


    async loadProjects() {
        const token = await this.$auth.CoreToken;
        const query = `?userId=${this.$coreAuth.user?.principal.id}`;
        const r = await this.$coreApi.Get<ProjectPrincipalResponse[]>(`Project${query}`, null, token);
        const parent = this;
        r.match({
            ok: (r) => {
                parent.projects = r
            },
            err: (e) => {
                (this.$refs.wrap as any).SubmitError(e)
            }
        })
    }

    async mounted() {
        await this.loadProjects();
    }
}
</script>
